import { Component, OnInit } from '@angular/core';
import { select, Store } from '@ngrx/store';
import { Observable } from 'rxjs';

import { State } from '../../store';
import { Logout } from '../../store/actions/auth.actions';
import { isLoggedInAuthSelector } from '../../store/selectors/auth.selectors';

@Component({
  selector: 'app-topbar',
  templateUrl: './topbar.component.html',
  styleUrls: ['./topbar.component.css']
})
export class TopbarComponent implements OnInit {
	public isLoggedIn$: Observable<boolean>;
	
  constructor(
		private store: Store<State>,
	) {}

  ngOnInit(): void {
		this.isLoggedIn$ = this.store.pipe(
			select(isLoggedInAuthSelector)
		);
	}

	public onLogout(): void {
		this.store.dispatch(new Logout());
	}
}
